/* Microsoft SQL Server - Scripting			*/
/* Server: DDTTHUMPER					*/
/* Database: StateU2					*/
/* Creation Date 4/1/97 10:35:56 AM 			*/
use stateu
go
/****** Object:  Stored Procedure dbo.ClassList    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.ClassList') and sysstat & 0xf = 4)
	drop procedure dbo.ClassList
GO

/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.CurrentEnrollment') and sysstat & 0xf = 4)
	drop procedure dbo.CurrentEnrollment
GO

/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.GetStudentGPA') and sysstat & 0xf = 4)
	drop procedure dbo.GetStudentGPA
GO

/****** Object:  View dbo.StudentsInClass    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.StudentsInClass') and sysstat & 0xf = 2)
	drop view dbo.StudentsInClass
GO

/****** Object:  Table dbo.Enrollment    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.Enrollment') and sysstat & 0xf = 3)
	drop table dbo.Enrollment
GO

/****** Object:  Table dbo.Classes    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.Classes') and sysstat & 0xf = 3)
	drop table dbo.Classes
GO

/****** Object:  Table dbo.Students    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.Students') and sysstat & 0xf = 3)
	drop table dbo.Students
GO

/****** Object:  Table dbo.Feedback    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.Feedback') and sysstat & 0xf = 3)
	drop table dbo.Feedback
GO

/****** Object:  Table dbo.Majors    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.Majors') and sysstat & 0xf = 3)
	drop table dbo.Majors
GO

/****** Object:  User Defined Datatype ClassIDType    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from systypes where name = 'ClassIDType')
	exec sp_droptype 'ClassIDType'
GO

/****** Object:  Rule dbo.ClassIDRule    Script Date: 4/1/97 10:35:59 AM ******/
if exists (select * from sysobjects where id = object_id('dbo.ClassIDRule') and sysstat & 0xf = 7)
	drop rule dbo.ClassIDRule
GO

/****** Object:  Rule dbo.ClassIDRule    Script Date: 4/1/97 10:35:59 AM ******/
/****** Object:  Rule dbo.ClassIDRule    Script Date: 3/31/97 5:29:33 PM ******/
/****** Object:  Rule dbo.ClassIDRule    Script Date: 3/31/97 4:46:26 PM ******/
/****** Object:  Rule dbo.ClassIDRule    Script Date: 3/31/97 4:40:23 PM ******/
/****** Object:  Rule dbo.ClassIDRule    Script Date: 2/4/97 2:48:25 PM ******/
create rule ClassIDRule as @ClassID like '[A-Z][A-Z][0-9][0-9][0-9]'





GO

/****** Object:  User Defined Datatype ClassIDType    Script Date: 4/1/97 10:35:59 AM ******/
setuser 'dbo'
GO

EXEC sp_addtype 'ClassIDType', 'char (5)', 'not null'
GO

setuser
GO

setuser 'dbo'
GO

EXEC sp_bindrule 'dbo.ClassIDRule', 'ClassIDType'
GO

setuser
GO

/****** Object:  Table dbo.Feedback    Script Date: 4/1/97 10:36:00 AM ******/
CREATE TABLE dbo.Feedback (
	Response smallint NOT NULL ,
	Useful smallint NULL ,
	Interactive smallint NULL ,
	Ease smallint NULL ,
	DateEntered datetime NULL CONSTRAINT DF_Feedback_DateEntered_1__10 DEFAULT (getdate())
)
GO

/****** Object:  Table dbo.Majors    Script Date: 4/1/97 10:36:03 AM ******/
CREATE TABLE dbo.Majors (
	MajorID int NOT NULL ,
	Description varchar (255) NULL ,
	CONSTRAINT PK_Majors_1__13 PRIMARY KEY  CLUSTERED 
	(
		MajorID
	)
)
GO

/****** Object:  Table dbo.Classes    Script Date: 4/1/97 10:36:06 AM ******/
CREATE TABLE dbo.Classes (
	ClassID ClassIDType NOT NULL ,
	Title varchar (255) NOT NULL ,
	MajorID int NOT NULL ,
	Seats int NULL ,
	StartDate datetime NULL ,
	CONSTRAINT PK_Classes_1__13 PRIMARY KEY  CLUSTERED 
	(
		ClassID
	),
	CONSTRAINT FK_Classes_1__10 FOREIGN KEY 
	(
		MajorID
	) REFERENCES dbo.Majors (
		MajorID
	)
)
GO

/****** Object:  Table dbo.Students    Script Date: 4/1/97 10:36:09 AM ******/
CREATE TABLE dbo.Students (
	StudentID int IDENTITY (1, 1) NOT NULL ,
	First_Name varchar (255) NULL ,
	Last_Name varchar (255) NULL ,
	MajorID int NULL ,
	CONSTRAINT PK_Students_1__13 PRIMARY KEY  CLUSTERED 
	(
		StudentID
	),
	CONSTRAINT FK_Students_1__10 FOREIGN KEY 
	(
		MajorID
	) REFERENCES dbo.Majors (
		MajorID
	)
)
GO

/****** Object:  Table dbo.Enrollment    Script Date: 4/1/97 10:36:11 AM ******/
CREATE TABLE dbo.Enrollment (
	ClassID ClassIDType NOT NULL ,
	StudentID int NOT NULL ,
	Grade int NULL ,
	CONSTRAINT PK_Enrollment_2__13 PRIMARY KEY  CLUSTERED 
	(
		ClassID,
		StudentID
	),
	CONSTRAINT FK_Enrollment_1__10 FOREIGN KEY 
	(
		ClassID
	) REFERENCES dbo.Classes (
		ClassID
	),
	CONSTRAINT FK_Enrollment_2__10 FOREIGN KEY 
	(
		StudentID
	) REFERENCES dbo.Students (
		StudentID
	)
)
GO

/****** Object:  View dbo.StudentsInClass    Script Date: 4/1/97 10:36:14 AM ******/
/****** Object:  View dbo.StudentsInClass    Script Date: 3/31/97 5:29:51 PM ******/
/****** Object:  View dbo.StudentsInClass    Script Date: 3/31/97 4:46:44 PM ******/
/****** Object:  View dbo.StudentsInClass    Script Date: 3/31/97 4:40:33 PM ******/
/****** Object:  View dbo.StudentsInClass    Script Date: 2/4/97 2:48:26 PM ******/
CREATE VIEW StudentsInClass AS SELECT      Classes.ClassID, Classes.Title, Students.StudentID,
                   Students.First_Name, Students.Last_Name
FROM         (Classes INNER JOIN Enrollment ON Classes.ClassID 
                       = Enrollment.ClassID) INNER JOIN Students ON Enrollment.StudentID

                       = Students.StudentID




GO

/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 4/1/97 10:36:14 AM ******/
/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 3/31/97 5:29:52 PM ******/
/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 3/31/97 4:46:45 PM ******/
/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 3/31/97 4:40:33 PM ******/
/****** Object:  Stored Procedure dbo.CurrentEnrollment    Script Date: 2/4/97 2:48:26 PM ******/
CREATE PROCEDURE CurrentEnrollment @ClassID char(5) AS
Select ClassID, Count(StudentID) as Students
from Enrollment 

where ClassID=@ClassID
group by classid




GO

/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 4/1/97 10:36:15 AM ******/
/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 3/31/97 5:29:53 PM ******/
/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 3/31/97 4:46:47 PM ******/
/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 3/31/97 4:40:35 PM ******/
/****** Object:  Stored Procedure dbo.GetStudentGPA    Script Date: 2/4/97 2:48:26 PM ******/
CREATE PROCEDURE GetStudentGPA @StudentID int AS
Select studentid, avg(grade) as GPA  from enrollment 
where studentid=@studentID
group by studentid 





GO

/****** Object:  Stored Procedure dbo.ClassList    Script Date: 4/1/97 10:36:15 AM ******/
/****** Object:  Stored Procedure dbo.ClassList    Script Date: 3/31/97 5:29:53 PM ******/
/****** Object:  Stored Procedure dbo.ClassList    Script Date: 3/31/97 4:46:47 PM ******/
/****** Object:  Stored Procedure dbo.ClassList    Script Date: 3/31/97 4:40:33 PM ******/
/****** Object:  Stored Procedure dbo.ClassList    Script Date: 2/4/97 2:48:26 PM ******/
CREATE PROCEDURE ClassList @classID char(5) AS
select StudentID, First_Name, Last_Name  from studentsinclass
where classid=@classID


GO


/****** Add data to Majors table ******/

INSERT INTO majors (MajorID, Description) VALUES (1,'Math')
INSERT INTO majors (MajorID, Description) VALUES (2,'History')
INSERT INTO majors (MajorID, Description) VALUES (3,'Music')
GO

/****** Add data to Classes  table ******/
/****** Add math classes ******/
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT100','Algebra',1,10,'1/1/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT101','Geometry',1,10,'1/10/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT300','Math Analysis',1,10,'1/10/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT150','Calculus I',1,10,'1/1/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT250','Calculus II',1,10,'1/10/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT350','Calculus III',1,10,'1/10/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT400','Trigonometry',1,10,'1/10/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MT401','Data Structures',1,10,'1/10/98')


/****** Add history classes ******/
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS100','European History',2,10,'1/20/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS200','World Politicians',2,15,'11/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS300','World Wars',2, 100,'05/01/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS310','Civil Wars',2,10,'1/20/98')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS320','French Revolution',2,15,'4/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS210','The Roman Empire',2,15,'4/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS350', 'Renaissance Art and Architecure',2,15,'4/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS400','The Roman Empire',2,15,'4/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS410','Chinese Emperors',2,15,'4/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('HS150','Russia: 1990s',2,15,'4/1/97')

/****** Add music classes ******/
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS100','Learning the Piano',3,50,'12/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS500','Music of the 17th Century',3,10,'10/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS130','Guitar',3,50,'12/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS200','Modern Composers',3,10,'10/1/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS250','Music of the East',3, 25,'05/01/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS350','Music Theory',3, 25,'05/01/97')
INSERT INTO classes (ClassID, Title, MajorID, Seats, StartDate) VALUES ('MS300','Composition',3, 25,'05/01/97')



/****** Add data to Students table ******/
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Abercrombie', 'Kim',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Archer', 'Linda',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Bacon', 'Dan',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Bowen', 'Kimberly',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Boyd-Vallejo', 'Shannon',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Chapman', 'Greg',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Chen', 'John',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Chor', 'Anthony',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Coake', 'Brandon',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Davis', 'Gregory',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Dirksen', 'Jay',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Dresen', 'Kate',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Eliasen', 'Deborah',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Erickson', 'Gregory',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Fallon', 'Scott',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Feig', 'Wayne.',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Forgrave', 'Bob',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Freilich', 'Edith',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Fretts', 'Lisa',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Funk', 'Don',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Gallagher', 'Karin',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Graham', 'Derek',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Grande', 'Jon',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Gray', 'Stephen',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Greenberg', 'Richard',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Greer', 'Deborah',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Haarsager', 'Gary',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Hance', 'Jim',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Hansen', 'Kylie',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Hartin', 'Jeffrey',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Harui', 'Roger',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Jennings', 'Laura',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Johnston', 'Tom',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Kim', 'Shane',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Klein', 'Allison',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Kobara', 'Linda',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Koch', 'Reed',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Krass', 'Cynthia',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('McCann', 'Thom',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('McColaugh', 'Jan',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Paoletti', 'Valerie',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Parrott', 'Viki',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Patten', 'Michael',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Perry', 'David',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Saada', 'Richard',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Scannell', 'Michael',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Schatz', 'Bethany',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Schettler', 'Becki (Rebecca)',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Szymanski', 'Shelly',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Tebbs', 'Janelle',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Thomas', 'Stephen',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Votava', 'Michelle',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Wood', 'John',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Wortman', 'Michelle',3)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Yim', 'Kevin',1)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Yoshida', 'Kim',2)
INSERT INTO students (Last_Name, First_Name, MajorID) VALUES ('Yukish', 'Gary',3)
GO

/****** Add data to Enrollment table ******/
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',1,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',2,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',8,4)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',7,4)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',5,DEFAULT)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT100',3,4)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT101',4,DEFAULT)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT101',7,0)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT101',5,DEFAULT)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT300',15,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT300',16,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MT300',17,4)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS100',5,3)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS200',8,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS200',4,4)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS310',15,DEFAULT)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS310',14,DEFAULT)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS310',22,DEFAULT)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS320',19,2)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS320',3,4)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('HS320',7,0)

INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MS250',5,1)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MS250',4,4)
INSERT INTO enrollment (ClassID, StudentID, Grade) VALUES ('MS250',16,4)
GO


